



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Nice Sequence_线段树***</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Nice Sequence_线段树***</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 01:06:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>Description</p>
<div>
<div>
<p>Let us consider the sequence a<sub>1</sub>,&nbsp;a<sub>2</sub>,...,&nbsp;a<sub>n</sub>&nbsp;of non-negative integer numbers. Denote as c<sub>i,j</sub>&nbsp;the number&nbsp;of occurrences of the number i among a<sub>1</sub>,a<sub>2</sub>,...,&nbsp;a<sub>j</sub>. We call the sequence k-nice if for all i<sub>1</sub>&lt;i<sub>2</sub>&nbsp;and for&nbsp;all j the following condition is satisfied: c<sub>i1,j</sub>&nbsp;&ge; c<sub>i2,j&nbsp;</sub>&minus;k.</p>
<p>Given the sequence a<sub>1</sub>,a<sub>2</sub>,...,&nbsp;a<sub>n</sub>&nbsp;and the number k, find its longest prefix that is k-nice.</p>
</div>
</div>
</div>
<div>
<p>Input</p>
<div>
<div>&nbsp;&nbsp; &nbsp; &nbsp;The first line of the input file contains n and k (1 &le; n &le; 200 000, 0 &le; k &le; 200 000). The second line&nbsp;contains n integer numbers ranging from 0 to n.</div>
</div>
</div>
<div>
<p>Output</p>
<div>
<div>&nbsp; &nbsp; &nbsp; Output the greatest&nbsp;<strong>l</strong>&nbsp;such that the sequence a&nbsp;<sub>1</sub>,&nbsp;a&nbsp;<sub>2</sub>,...,&nbsp;a&nbsp;<sub>l</sub>&nbsp;is k-nice.</div>
</div>
</div>
<div>
<p>Sample Input</p>
<div>
<div>
<pre class="prettyprint linenums">10 1<br />
0 1 1 0 2 2 1 2 2 3<br />
2 0<br />
1 0
</pre>
</div>
</div>
</div>
<div>
<p>Sample Output</p>
<div>
<div>
<pre class="prettyprint linenums">8<br />
1</pre>
</div>
</div>
</div>
<p>【题意】用线段树维护 0到A[i]-1间的最小值，用F[A[i]] 统计频率。判断 0 到 A[i]-1范围内的最小值与F[A[i]]-K的大小即可。</p>
<p>【思路】cnt[i]是当前i出现的次数。每次读入一个数a进来，cnt[a]++。只要c[1]...c[a-1]都满足c[i]+K&gt;=c[a]就可以了，一旦不满足就结束程序并输出答案。</p>
<p>那么找c[1]...c[a-1]中最小的即可。如果最小的都满足不等式就不用验证其他的了。于是用线段树实现这个查询操作。</p>
<p>注意线段树建树从[0,N]开始，因为The second line&nbsp;contains n integer numbers ranging from&nbsp;0&nbsp;to n.</p>
<p>参考：http://blog.csdn.net/liao_jingyi/article/details/43531123</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
#include&lt;stdio.h&gt;<br />
#include&lt;string.h&gt;<br />
using namespace std;<br />
const int N=+;<br />
int cnt[N];<br />
int n,k;<br />
struct node<br />
{<br />
    int l,r,sum;<br />
} tree[N*];<br />
void build(int k,int l,int r)<br />
{<br />
    tree[k].l=l;<br />
    tree[k].r=r;<br />
    if(l==r) return ;<br />
    int mid=l+r&gt;&gt;;<br />
    build(k*,l,mid);<br />
    build(k*+,mid+,r);<br />
}<br />
void update(int x,int k)<br />
{<br />
    if(tree[k].l==tree[k].r)<br />
    {<br />
        tree[k].sum++;<br />
        return ;<br />
    }<br />
    int mid=(tree[k].l+tree[k].r)&gt;&gt;;<br />
    if(x&lt;=mid) update(x,k*);<br />
    else update(x,k*+);<br />
    tree[k].sum=min(tree[k*].sum,tree[k*+].sum);<br />
}

int query(int x,int k)<br />
{<br />
    if(x&gt;=tree[k].r) return tree[k].sum;<br />
    int mid=(tree[k].l+tree[k].r)&gt;&gt;;<br />
    int ansl=query(x,k*);<br />
    int ansr=0x3f3f3f3f;<br />
    if(mid&lt;x) ansr=query(x,k*+);<br />
    return min(ansl,ansr);<br />
}

int main()<br />
{<br />
    scanf("%d%d",&amp;n,&amp;k);<br />
    build(,,n);<br />
    int ans=;<br />
    for(int i=; i&lt;=n; i++)<br />
    {<br />
        int a;<br />
        scanf("%d",&amp;a);<br />
        cnt[a]++;<br />
        update(a,);<br />
        if(query(a,)+k&gt;=cnt[a])<br />
            ans=i;<br />
        else break;<br />
    }<br />
    printf("%d\n",ans);

    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k61rqj.html">【完全开源】微信客户端&period;NET版</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8koo77q.html">JSON解析和XML解析对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwmj3q.html">Python学习之路&mdash;&mdash;基础篇（1&rpar;字符串格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j4kx09.html">vim全选，全部复制，全部删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11nvx8.html">read 判定用户输入的状态后运行相应的结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnl64v8.html">C&num;获取当前路径的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ww5j8.html">运行时环境（The Runtime Environment）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ol75j9.html">&amp;lt&semi;转&amp;gt&semi;HTML&plus;CSS总结&sol;深入理解CSS盒子模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydxzdmq.html">Android中获取正在运行的应用程序-----ActivityManager&period;RunningAppProcessInfo类详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde3z3x9.html">important的妙用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1kxz8.html">jdbc mysql - Column count doesn&amp;&num;39&semi;t match value count at row 1&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mykykq.html">第10章 PHP异常处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7wjy8.html">Oracle游标使用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoekl1q.html">uva10003 - Cutting Sticks&lpar;简单动规&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk4e2v8.html">ASP&period;MVC当URL跳转时候参数的安全性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojzd55q.html">Python爬虫入门教程 27-100 微医挂号网专家团队数据抓取pyspider</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyvee39.html">freemarker -include</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv23wmj9.html">veri HDL  modeisim仿真：test bench文件编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rg6v08.html">CSS实现英文或拼音单词首字母大写</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kokdzrq.html">windows下查看端口占用以及进程名称</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/39rlekr9.html">原创开源项目HierarchyViewer for iOS 2&period;1 Beta新功能介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8orzpe8.html">基于ASP&period;NET MVC定时执行任务调度</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j7k0g9.html">&lbrack;问题2014A09&rsqb;  解答</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq41x03q.html">&lbrack;转&rsqb;（三）unity4&period;6Ugui中文教程文档-------概要-UGUI Basic Layout</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdv60xq.html">Maven学习（四）-- 生命周期和插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyjwxgq.html">《BI那点儿事》Cube的存储</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ymdgq.html">用cython提升python的性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j40409.html">js模板引擎</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kgplj9.html">D3&period;js 用层画条形图</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o01ll8.html">解决maven的报错</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
